<?php
/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\ActivitylogService;
use App\Http\Services\LokasiitemService;
use App\Http\Validators\LokasiitemValidator;

class LokasiitemController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $kapal;
    private $activityLog;
    /**
     * Lokasiitem constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new LokasiitemService();
        $this->validator = new LokasiitemValidator();
        $this->activityLog = new ActivitylogService();

    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $this->validator->beforeInsert($request->all());
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {            
            $ID = $this->baseService->store($request->all());
            $auth = json_decode($request->session()->get('auth'));
            $activityLog = [
                                "username" => $auth->username, 
                                "urlTransaksi" => "lokasiitem", 
                                "namaTransaksi" => "Sub-Inventory", 
                                "date" => date("Y-m-d H:i:s"), 
                                "activity" => "CREATE", 
                                "refId" => $ID, 
                                "date_updated" => date("Y-m-d H:i:s"), 
                                "kapalId" => $auth->kapalId, 
                                "deskripsi" => $auth->name . " just <b>created</b> new Sub-Inventory <a href=\"" . url("administrator/lokasiitem/" . $ID) . "\">here</a>"
                            ];
            $this->activityLog->store($activityLog);
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/lokasiitem")->with("successMessages", "Data has been created");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = ["id" => "id"
            , "namaLokasi" => "Nama Lokasi"
        ];
        $this->data["criteria"] = ["id" => "id"
            , "namaLokasi" => "Nama Lokasi"
        ];
        $this->data["ordering"] = [
            //"id:asc" => "ID &uarr;"
            //, "id:desc" => "ID &darr;"
            
             "namaLokasi:asc" => "Sub-Inventory &uarr;"
            , "namaLokasi:desc" => "Sub-Inventory &darr;"
            , "lokasi:asc" => "Deskripsi &uarr;"
            ,"lokasi:desc" => "Deskripsi &darr;"
        ];
        $this->data["lokasiitems"] = $this->baseService->paging($request);
        return view("modules.lokasiitem.lokasiitem_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit($id)
    {
        $this->data["lokasiitem"] = $this->baseService->show($id);
        return view("modules.lokasiitem.lokasiitem_edit", $this->data);
    }

    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());
            $auth = json_decode($request->session()->get('auth'));
            $activityLog = [
                                "username" => $auth->username, 
                                "urlTransaksi" => "lokasiitem", 
                                "namaTransaksi" => "Sub-Inventory", 
                                "date" => date("Y-m-d H:i:s"), 
                                "activity" => "UPDATE", 
                                "refId" => $id, 
                                "date_updated" => date("Y-m-d H:i:s"), 
                                "kapalId" => $auth->kapalId, 
                                "deskripsi" => $auth->name . " just <b>updated</b> Sub-Inventory <a href=\"" . url("administrator/lokasiitem/" . $id) . "\">here</a>"
                            ];
            $this->activityLog->store($activityLog);
            DB::commit();
            $this->sync();
            return redirect()->to("administrator/lokasiitem")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        return view("modules.lokasiitem.lokasiitem_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show($id)
    {
        $this->data["lokasiitem"] = $this->baseService->show($id);
        return view("modules.lokasiitem.lokasiitem_show", $this->data);
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }


}